#version 450 core
out vec4 FragColor;

in flat int Id;
in vec2 Texture;

uniform sampler2D uSampler[32];
uniform uint uTexturesCount;

void main() {
    vec4 color = vec4(0.0, 0.0, 0.0, 1.0);
    for(uint i = 0; i < uTexturesCount; ++i) {
        vec4 tcolor = texture(uSampler[i], Texture);
        if(tcolor.r != 0.0) {
            color.r = tcolor.r;
        }

        if(tcolor.g != 0.0) {
            color.g = tcolor.g;
        }

        if(tcolor.b != 0.0) {
            color.b = tcolor.b;
        }
    }

    FragColor = color;
}