#version 330 core
layout (location = 0) in vec2 aPos;
layout (location = 1) in vec2 aTex;

uniform mat4 uProj;
uniform mat4 uView;
uniform mat4 uModel[128];

uniform float uTime;

out vec2 Texture;

float process(vec2 pos, mat4 model, float time, int id) {
    return pos.y + sin(time + id * 0.01);
}

void main() {
    Texture = aTex;
    gl_Position = uProj * uView * uModel[gl_InstanceID] * vec4(aPos.x, process(aPos, uModel[gl_InstanceID], uTime, gl_InstanceID), 0.0, 1.0);
}