#version 450 core
layout (location = 0) in vec2 aPos;
layout (location = 1) in vec2 aTex;

uniform mat4 uModel;
uniform mat4 uView;
uniform mat4 uProj;

uniform mat4 uOffsets[128];

out vec2 Texture;
flat out int Id;

void main() {
    Texture = aTex;
    Id = gl_InstanceID;
    vec2 pos = vec2(aPos.x, aPos.y);
    

    gl_Position = uProj * uView * uModel * uOffsets[gl_InstanceID] * vec4(pos, 0.0, 1.0);
}