#pragma once

#include "Buffer.hpp"
#include "../textures/Texture.hpp"

namespace megu {
    class FrameBuffer : public Buffer {
        public:
            FrameBuffer() = delete;
            FrameBuffer(GLuint width, GLuint height);
   virtual ~FrameBuffer();

            inline const Texture & texture() const {return this->_texture;}
            GLuint rbo_identifier() const {return this->_rbo_id;}

            inline virtual GLuint identifier() const noexcept {return this->_id;}

            bool usable() const;

            virtual void bind() const;
            virtual void unbind() const;

            static void BindDefaultFrameBuffer();

        private:
            GLuint _id;
            GLuint _rbo_id;
            Texture _texture;
    }; 
}