#pragma once

#include <list>
#include <numeric>

namespace megu {
    namespace layout {
        enum Value : uint8_t {
            POSITION            = 3,
            FLAT                = 2,
            COLOR               = 3,
            NORMAL              = 3,
            TEXTURE             = 2,
            BORDER              = 2,
            ID                  = 1,
        };
    }

    using Layout_t = std::list<layout::Value>;
    using Layout_Initializer = std::initializer_list<layout::Value>;

    namespace layout {
        inline size_t weight(const Layout_t & layout) {
            return std::accumulate(layout.begin(), layout.end(), 0);
        }
    }
}