#pragma once

#include "Buffer.hpp"

#include <map>

#include "../shaders/Program.hpp"

namespace megu {
    template <class T>
    class ShaderStorageBuffer : public Buffer {
        public:
            ShaderStorageBuffer(T * = nullptr);
   virtual ~ShaderStorageBuffer();

            void setData(T *);
            void attach(const std::string &, const Program &);

            void bind() const override;
            void unbind() const override;
            inline GLuint identifier() const override {return this->_id;}

        private:
            T * _data;
            GLuint _id;
            std::map<const Program *, GLuint> _programs;
    };
}

#include "ShaderStorageBuffer.tpp"