#pragma once

#include <compare>
#include <GL/glew.h>

#include "Buffer.hpp"

namespace megu {
    class VertexArray : public Buffer {
        public:
            VertexArray(bool binded=false);
            VertexArray(const VertexArray &) = delete;
   virtual ~VertexArray();

            virtual GLuint identifier() const noexcept {return this->_vao;}

            virtual void bind() const;
            virtual void unbind() const;

            bool operator==(const VertexArray &) const;
            bool operator!=(const VertexArray &) const;
            bool operator<=(const VertexArray &) const;
            bool operator>=(const VertexArray &) const;
            bool operator()(const VertexArray &) const;

            bool operator<(const VertexArray &) const;
            bool operator>(const VertexArray &) const;

            std::strong_ordering operator<=>(const VertexArray &) const;

        private:
            GLuint _vao;
    };
}