#include "Renderer.hpp"

namespace megu {
    Renderer::Renderer(float x, float y)
    : _view(0, 0, x, y) {
        glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
        glEnable(GL_BLEND);
    }

    void Renderer::setClearColor(float r, float g, float b, float a) const {
        glClearColor(r, g, b, a);
    }

    void Renderer::clear() const {
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    }

    void Renderer::render(const Window & w, Renderable & r, const TextureArray & a) {
        render_ext(r, w, this->_view, a);
    }
}