#pragma once

#include <optional>

#include <engine/utility/reference_sorter.hpp>
#include <engine/graphics/back/buffers/FrameBuffer.hpp>
#include <engine/graphics/back/cameras/View.hpp>

#include <engine/io/Window.hpp>
#include <engine/graphics/front/object/Renderable.hpp>
#include <engine/graphics/front/engine/TextureArray.hpp>

#include <engine/graphics/front/object/Renderable.hpp>

namespace megu {
    class Producer {
        public:
            template <class T>
            static Renderable produce(T & object, Module<T> & modul) {
                return Renderable{object, modul};
            }
    };

    class Renderer : public Producer {
        public:
            Renderer() = delete;
            Renderer(float, float);
           ~Renderer() = default;
            
            const glm::vec2 dimension() const {return this->_view.dimension();}

            void clear() const;
            void setClearColor(float, float, float, float = 1.f) const;
            void render(const Window &, Renderable &, const TextureArray &);

            View & view() {return this->_view;}

        private:
            View _view;
    };
}