#pragma once

#include "Module.hpp"

#include <engine/graphics/back/buffers/VertexArray.hpp>
#include <engine/graphics/back/buffers/VerticeBuffer.hpp>
#include <engine/graphics/back/shaders/Program.hpp>

#include <engine/graphics/front/object/Image.hpp>
#include <engine/utility/ref_set.hpp>

namespace megu {
    class Image_Module : public Module<ref_set<Image>> {
        public:
            Image_Module();

            void draw(const ref_set<Image> &, const Camera &, const Window &) const override;

        private:
            VertexArray _vao;
            VerticeBuffer _vbo;
            Program _program;
    };


}