#pragma once

#include "Module.hpp"

#include <engine/graphics/back/buffers/VertexArray.hpp>
#include <engine/graphics/back/buffers/VerticeBuffer.hpp>
#include <engine/graphics/back/shaders/Program.hpp>

#include <engine/graphics/front/object/Sprite.hpp>
#include <engine/utility/ref_set.hpp>

namespace megu {
    class Sprite_Module : public Module<ref_set<Sprite>> {
        public:
            Sprite_Module();

            void draw(const ref_set<Sprite> &, const Camera &, const Window &) const override;

        private:
            VertexArray _vao;
            VerticeBuffer _vbo;
            Program _program;
    };
}