#pragma once

#include "Module.hpp"

#include <engine/graphics/back/buffers/VertexArray.hpp>
#include <engine/graphics/back/buffers/VerticeBuffer.hpp>
#include <engine/graphics/back/shaders/Program.hpp>

#include <engine/graphics/front/object/TileArray.hpp>

namespace megu {
    class TileArray_Module : public Module<TileArray> {
        public:
            TileArray_Module();

            virtual void draw(const TileArray &, const Camera &, const Window &) const override;

        private:
            VertexArray _vao;
            VerticeBuffer _vbo;
            Program _program;
    };
}