#include "Sprite.hpp"

namespace megu {
    Sprite::Sprite()
    : _frame(0, 0, 0, 0) {}

    Sprite::Sprite(const std::filesystem::path & path, bool flip)
    : _frame(0, 0, 0, 0) {
        this->load(path, flip);
    }

    Sprite::Sprite(const std::filesystem::path & path, const Frame & frame, bool flip)
    : _frame(frame) {
        this->load(path, flip);
    }

    void Sprite::load(const std::filesystem::path & path, bool flip) {
        TextureBuffer buffer;
        buffer.load(path, flip);
        this->load(buffer);
    }

    void Sprite::load(const TextureBuffer & buffer) {
        this->setSize(static_cast<float>(buffer.width()), static_cast<float>(buffer.height()));
        this->_texture.store(buffer);
    }

    void Sprite::link(const Texture & texture) {
        this->setSize(static_cast<float>(texture.width()), static_cast<float>(texture.height()));
        this->_texture = texture;
    }
}