#include "isometric_sorter.hpp"

#include <engine/graphics/back/geometry/Transformable.hpp>

namespace megu {
    bool isometric_sorter::operator()(const Transformable & a, const Transformable & b) const {
        if(a.z() != b.z()) {
            return a.z() > b.z();
        }

        if(a.y() != b.y()) {
            return a.y() > b.y();
        }

        if(a.x() != b.x()) {
            return a.x() > b.x();
        }

        return &a > &b;
    }
}