#pragma once

#include <GLFW/glfw3.h>

namespace megu {
    class Keyboard {
        public:
            enum class Action {
                PRESS   = GLFW_PRESS,
                HOLD    = GLFW_REPEAT,
                RELEASE = GLFW_RELEASE,
            };

            enum class Key {
                UTIL_SPACE      = GLFW_KEY_SPACE,
                UTIL_APOSTROPHE = GLFW_KEY_APOSTROPHE,
                UTIL_COMMA      = GLFW_KEY_COMMA,
                UTIL_MINUS      = GLFW_KEY_MINUS,
                UTIL_PERIOD     = GLFW_KEY_PERIOD,
                UTIL_SEMICOLON  = GLFW_KEY_SEMICOLON,
                UTIL_EQUAL      = GLFW_KEY_EQUAL,

                UTIL_LEFT_BRACKET   = GLFW_KEY_LEFT_BRACKET ,
                UTIL_RIGHT_BRACKET  = GLFW_KEY_RIGHT_BRACKET,
                UTIL_BACKSLASH      = GLFW_KEY_BACKSLASH,
                UTIL_GRAVE_ACCENT   = GLFW_KEY_GRAVE_ACCENT,
                UTIL_WORLD_1        = GLFW_KEY_WORLD_1,
                UTIL_WORLD_2        = GLFW_KEY_WORLD_2,
                UTIL_ESCAPE         = GLFW_KEY_ESCAPE,
                UTIL_TAB            = GLFW_KEY_TAB,
                UTIL_BACKSPACE      = GLFW_KEY_BACKSPACE,
                UTIL_INSERT         = GLFW_KEY_INSERT,
                UTIL_DELETE         = GLFW_KEY_DELETE,

                ARROW_UP    = GLFW_KEY_UP,
                ARROW_DOWN  = GLFW_KEY_DOWN,
                ARROW_LEFT  = GLFW_KEY_LEFT,
                ARROW_RIGHT = GLFW_KEY_RIGHT,

                UTIL_PAGE_UP    = GLFW_KEY_PAGE_UP,
                UTIL_PAGE_DOWN  = GLFW_KEY_PAGE_DOWN,

                NUM_0   = GLFW_KEY_0,
                NUM_1   = GLFW_KEY_1,
                NUM_2   = GLFW_KEY_2,
                NUM_3   = GLFW_KEY_3,
                NUM_4   = GLFW_KEY_4,
                NUM_5   = GLFW_KEY_5,
                NUM_6   = GLFW_KEY_6,
                NUM_7   = GLFW_KEY_7,
                NUM_8   = GLFW_KEY_8,
                NUM_9   = GLFW_KEY_9,

                LETTER_A = GLFW_KEY_A,
                LETTER_Z = GLFW_KEY_Z,
                LETTER_E = GLFW_KEY_E,
                LETTER_R = GLFW_KEY_R,
                LETTER_T = GLFW_KEY_T,
                LETTER_Y = GLFW_KEY_Y,
                LETTER_U = GLFW_KEY_U,
                LETTER_I = GLFW_KEY_I,
                LETTER_O = GLFW_KEY_O,
                LETTER_P = GLFW_KEY_P,
                LETTER_Q = GLFW_KEY_Q,
                LETTER_S = GLFW_KEY_S,
                LETTER_D = GLFW_KEY_D,
                LETTER_F = GLFW_KEY_F,
                LETTER_G = GLFW_KEY_G,
                LETTER_H = GLFW_KEY_H,
                LETTER_J = GLFW_KEY_J,
                LETTER_K = GLFW_KEY_K,
                LETTER_L = GLFW_KEY_L,
                LETTER_M = GLFW_KEY_M,
                LETTER_W = GLFW_KEY_W,
                LETTER_X = GLFW_KEY_X,
                LETTER_C = GLFW_KEY_C,
                LETTER_V = GLFW_KEY_V,
                LETTER_B = GLFW_KEY_B,
                LETTER_N = GLFW_KEY_N,

                FUNCTION_1 = GLFW_KEY_F1,
                FUNCTION_2 = GLFW_KEY_F2,
                FUNCTION_3 = GLFW_KEY_F3,
                FUNCTION_4 = GLFW_KEY_F4,
                FUNCTION_5 = GLFW_KEY_F5,
                FUNCTION_6 = GLFW_KEY_F6,
                FUNCTION_7 = GLFW_KEY_F7,
                FUNCTION_8 = GLFW_KEY_F8,
                FUNCTION_9 = GLFW_KEY_F9,
                FUNCTION_10 = GLFW_KEY_F10,
                FUNCTION_11 = GLFW_KEY_F11,
                FUNCTION_12 = GLFW_KEY_F12,
                FUNCTION_13 = GLFW_KEY_F13,
                FUNCTION_14 = GLFW_KEY_F14,
                FUNCTION_15 = GLFW_KEY_F15,
                FUNCTION_16 = GLFW_KEY_F16,
                FUNCTION_17 = GLFW_KEY_F17,
                FUNCTION_18 = GLFW_KEY_F18,
                FUNCTION_19 = GLFW_KEY_F19,
                FUNCTION_20 = GLFW_KEY_F20,
                FUNCTION_21 = GLFW_KEY_F21,
                FUNCTION_22 = GLFW_KEY_F22,
                FUNCTION_23 = GLFW_KEY_F23,
                FUNCTION_24 = GLFW_KEY_F24,
                FUNCTION_25 = GLFW_KEY_F25,
            };

            enum class Mod {
                SHIFT       = GLFW_MOD_SHIFT,
                CONTROL     = GLFW_MOD_CONTROL,
                ALT         = GLFW_MOD_ALT,
                SUPER       = GLFW_MOD_SHIFT,
                CAPS_LOCK   = GLFW_MOD_CAPS_LOCK,
                NUM_LOCK    = GLFW_MOD_NUM_LOCK
            };

            virtual void on(Key, int, Action, Mod) = 0;
    };
}