#pragma once

#include <GLFW/glfw3.h>

namespace megu {
    class Mouse {
        public:
            enum class Button {
                BUTTON_1_LEFT   = GLFW_MOUSE_BUTTON_1,
                BUTTON_2_RIGHT  = GLFW_MOUSE_BUTTON_2,
                BUTTON_3_MIDDLE = GLFW_MOUSE_BUTTON_3,
                BUTTON_4        = GLFW_MOUSE_BUTTON_4,
                BUTTON_5        = GLFW_MOUSE_BUTTON_5,
                BUTTON_6        = GLFW_MOUSE_BUTTON_6,
                BUTTON_7        = GLFW_MOUSE_BUTTON_7,
                BUTTON_8_LAST   = GLFW_MOUSE_BUTTON_8,
            };

            enum class Action {
                PRESS   = GLFW_PRESS,
                HOLD    = GLFW_REPEAT,
                RELEASE = GLFW_RELEASE,
            };

            enum class Mod {
                SHIFT       = GLFW_MOD_SHIFT,
                CONTROL     = GLFW_MOD_CONTROL,
                ALT         = GLFW_MOD_ALT,
                SUPER       = GLFW_MOD_SHIFT,
                CAPS_LOCK   = GLFW_MOD_CAPS_LOCK,
                NUM_LOCK    = GLFW_MOD_NUM_LOCK
            };

            virtual void on(Button, Action, Mod) = 0;
            virtual void on(double, double) = 0;
            virtual void on(bool) = 0;
    };
}