#pragma once

#include <memory>

#include "Window.hpp"
#include "Keyboard.hpp"
#include "Mouse.hpp"

namespace megu {
    class Profiler {
        public:
            inline Keyboard * keyboard() const {return this->_keyboard.get();}
            inline Mouse * mouse() const {return this->_mouse.get();}

            void set(Keyboard *);
            void set(Mouse *);
            
            void link(const Window &) const;

        private:
            std::unique_ptr<Keyboard> _keyboard;
            std::unique_ptr<Mouse> _mouse;
    };
}