#pragma once

#include <string>
#include <GL/glew.h>
#include <GLFW/glfw3.h>

namespace megu {
    class Window {
        public:
            Window();
            Window(const Window &) = delete;
           ~Window() = default;

            uint16_t width() const;
            uint16_t height() const;

            bool isOpen() const;

            void resize(uint16_t, uint16_t);
            void setTitle(const std::string &);
            void open(const std::string &, uint16_t, uint16_t);
            void close();

            void pollEvents();
            void swapBuffers();

            inline GLFWwindow * ptr() const {return this->_pointer;}

            inline static double Time() {return glfwGetTime();}

        private:
            GLFWwindow * _pointer;
    };
}