#pragma once

#include <glm/glm.hpp>

namespace megu {
    class Position {
        public:
            Position();
            Position(float, float, float = 0.f);
            Position(const glm::vec3 &);
            Position(const Position &);
            Position operator=(const Position &);
   virtual ~Position() = default;

            inline float x() const {return this->_position.x;}
            inline float y() const {return this->_position.y;}
            inline float z() const {return this->_position.z;}

            inline void set(const glm::vec3 & position) {this->_position = position;}
            inline void set(float x, float y, float z) {this->set({x, y, z});}

            void move(const glm::vec3 &);
            inline void move(float x, float y, float z) {this->move({x, y, z});}

            bool operator==(const Position &) const;
            bool operator!=(const Position &) const;

            friend Position operator+(const Position &, const Position &);
            friend Position operator-(const Position &, const Position &);
            friend Position operator*(const Position &, const Position &);
            friend Position operator/(const Position &, const Position &);

            friend bool operator<(const Position &, const Position &);
            friend bool operator>(const Position &, const Position &);

            friend bool operator<=(const Position &, const Position &);
            friend bool operator>=(const Position &, const Position &);

        private:
            glm::vec3 _position;
    };

    using Direction = Position;
}