#include "Collision.hpp"

namespace megu {
    Collision::Collision(Tangible & source, Tangible & target)
    : _source(source), _target(target) {}

    Collision::Collision(const Collision & src)
    : _source(src._source), _target(src._target) {}

    Collision Collision::operator=(const Collision & src) {
        this->_source = src._source;
        this->_target = src._target;
        return *this;
    }

    bool Collision::operator&(const Tangible & tangible) const {
        return this->_source == tangible || this->_target == tangible;
    }

    bool Collision::operator==(const Collision & collision) const {
        return this->_source == collision._source && this->_target == collision._target;
    }

    bool Collision::operator!=(const Collision & collision) const {
        return !(*this == collision);
    }
}