#pragma once

#include "Tangible.hpp"

namespace megu {
    class Collision {
        public:
            Collision() = delete;
            Collision(Tangible &, Tangible &);
            Collision(const Collision &);
            Collision operator=(const Collision &);

            inline const Tangible & source() const {return this->_source;}
            inline const Tangible & target() const {return this->_target;}

            bool operator&(const Tangible &) const;
            bool operator==(const Collision &) const;
            bool operator!=(const Collision &) const;

        private:
            Tangible & _source;
            Tangible & _target;
    };
}