#include "Tangible.hpp"

#include <optional>
#include <iostream>

namespace megu {
    Tangible::Tangible()
    : _box({0, 0, 0}, {1, 1, 1}) {}

    Tangible::Tangible(const Position & position, const Dimension & dimension) 
    : _box(position, dimension) {}

    std::optional<SquareBox> Tangible::isColliding(const Tangible & entity) const {
        if(this != &entity && this->_box.intersect(entity._box)) {
            return this->_box;
        }
        return {};
    }

    std::optional<SquareBox> Tangible::isColliding(const SquareBox & box) const {
        if(this->_box.intersect(box)) {
            return this->_box;
        }
        return {};
    }

    bool Tangible::operator==(const Tangible & entity) const {
        return this->_box == entity._box;
    }

    std::optional<SquareBox> Tangible::operator|(const Tangible & tangible) const {
        return this->isColliding(tangible);
    }

    std::optional<SquareBox> Tangible::operator|(const SquareBox & box) const {
        return this->isColliding(box);
    }
}