#pragma once

#include <kernel/front/Kernel.hpp>
#include <game/back/message/Event.hpp>

namespace megu::game {
    class Level;

    class GameObject {
        public:
            virtual void setup(kernel::Kernel &, Level &) = 0;
            virtual void destroy(kernel::Kernel &, Level &) = 0;
            virtual void apply(kernel::Kernel &) = 0;
    };

    class GameEvent {
        public:
            virtual void on(const kernel::Prop &, const Event &) = 0;
            virtual std::optional<Event> on() const = 0;
    };

    class GameProps : public GameObject, public GameEvent {
        public: 
            GameProps() = delete;
            GameProps(kernel::Prop *);
   virtual ~GameProps() = default;

            inline kernel::Prop * parent() const {return this->_parent;}

        private:
            kernel::Prop * _parent;

    };
}