#pragma once

#include "StatsAlterator.hpp"

namespace megu::game {
    class Event {
        public:
            enum Type : uint32_t {
                SOLID  = 1,
                DAMAGE = 2,
            };

            Event() = delete;
            Event(uint32_t);

            std::optional<uint32_t> get(size_t) const;
            void set(size_t, uint32_t);

            bool operator&(const uint32_t &) const;

        private:
            uint32_t _type;
            StatsAlterator<uint32_t> _stats;
    };
}

    
    