#pragma once

#include <stdint.h>

namespace megu::game {
    class Damagable {
        public:
            Damagable(uint32_t = 0, bool = false);
   virtual ~Damagable() = default;

            inline uint32_t getLife() const {return this->_life;}
            inline bool isAlive() const {return !this->_dead;}
            inline bool isDead() const {return this->_dead;}

            inline void setLife(uint32_t l) {this->_life = l;} 
            inline void setDead(bool s) {this->_dead = s;}

            inline void kill() {this->_dead = true;}

            void damage(uint32_t);
            void heal(uint32_t);

        private:
            uint32_t _life;
            bool _dead;
    };
}