#pragma once

#include <kernel/front/props/PropsDynamic.hpp>
#include <game/back/GameObject.hpp>

namespace megu::game {
    class Enemy : public kernel::PropsDynamic, public GameProps {
        public:
            Enemy(float, float, float, float, std::filesystem::path &);

            void setup(kernel::Kernel &, Level &) override;
            void destroy(kernel::Kernel &, Level &) override;

            

            void on(const kernel::Prop &, const Event &) override;
            std::optional<Event> on() const override;

            void apply(kernel::Kernel &) override;

            void onDamage(const Event &);
            void onSolide(const Event &); 

        private:
            kernel::Sprite _sprite;
            kernel::Movable _movable;
    };
}