#include "Level.hpp"

namespace megu::game {
    Level::Level(const std::string & name)
    :  _name(name) {}

    std::optional<std::reference_wrapper<GameProps>> Level::get(Identifiable & id) const {
        for(auto it = this->_objecs.begin(); it != this->_objecs.end(); ++it) {
            if(it->first == id) {
                return *it->second;
            }
        }
        return {};
    }

    void Level::add(GameProps * prop) {
        this->_objecs.insert({prop->parent()->id(), prop});
    }

    void Level::apply(kernel::Kernel & kernel) {
        for(auto & [id, prop] : this->_objecs) {
            kernel.push(*prop->parent());
        }
    }

    void Level::setup(kernel::Kernel & kernel, Level & level) {
        
    }

    void Level::destroy(kernel::Kernel & kernel, Level & level) {
        for(auto & [id, prop] : this->_objecs) {
            kernel.remove(*prop->parent());
        }
    }
}