#pragma once

#include <game/back/GameObject.hpp>
#include <kernel/front/props/Props.hpp>

namespace megu::game {
    class Level : public GameObject {
        public:
            Level(const std::string &);

            inline const std::string & name() const {return this->_name;}

            void add(GameProps *);

            std::optional<std::reference_wrapper<GameProps>> get(Identifiable &) const;

            virtual void apply(kernel::Kernel &) override final;
            virtual void setup(kernel::Kernel &, Level &) override;
            virtual void destroy(kernel::Kernel &, Level &) override final;

        private:
            std::string _name;
            std::map<size_t, GameProps *> _objecs;
    };
}