#pragma once

#include <kernel/front/props/PropsTileMap.hpp>
#include <game/back/GameObject.hpp>
#include <game/back/object/tile/Tile.hpp>

namespace megu::game {
    class Terrain : public kernel::PropsTileMap, public GameProps {
        public:
            Terrain() = delete;
            Terrain(float, float, float, float, const std::filesystem::path &, size_t, size_t, float, size_t);
   virtual ~Terrain() = default;

            void setup(kernel::Kernel &, Level &) override;
            void destroy(kernel::Kernel &, Level &) override;

            void setValue(size_t, size_t, size_t);
            void setTileEvent(size_t, Tile *);
           
            
            void apply(kernel::Kernel &) override;
            void on(const kernel::Prop &, const Event &) override;
            std::optional<Event> on() const override;

            inline kernel::Tilemap & graphic() {return this->_graphic;}
            inline kernel::TileArray & phyisc() {return this->_physic;}

        private:
            kernel::Tilemap _graphic;
            kernel::TileArray _physic;
            std::map<size_t, std::shared_ptr<Tile>> _event;

    };
}