#include "KlinckKeys.hpp"

#include <game/front/Layer.hpp>
#include <optional>

namespace megu::game {
    KlinckKeyProfile::KlinckKeyProfile(Klinck & player, kernel::Kernel & kernel)
    : _player(player), _kernel(kernel) {}

    void KlinckKeyProfile::on(Key key, int code, Action action, Mod mode) {
        if(key == Keyboard::Key::ARROW_LEFT) {
            this->_player.setMovingDirection(Klinck::Direction::LEFT, action != Action::RELEASE);
            //this->_player.getGraphic().setAnimation(action == Action::RELEASE ? Klinck::Animation::IDL_LEFT : Klinck::Animation::WALK_LEFT);
            this->_player.getGraphic().setCurrentAnimation(Klinck::Animation::IDL_LEFT);
        }

        if(key == Keyboard::Key::ARROW_RIGHT) {
            this->_player.setMovingDirection(Klinck::Direction::RIGHT, action != Action::RELEASE);
            //this->_player.getGraphic().setAnimation(action == Action::RELEASE ? Klinck::Animation::IDL_RIGHT : Klinck::Animation::WALK_RIGHT);
            this->_player.getGraphic().setCurrentAnimation(Klinck::Animation::IDL_RIGHT);
        }

        if(key == Keyboard::Key::ARROW_UP) {
            this->_player.setMovingDirection(Klinck::Direction::UP, action != Action::RELEASE);
            //this->_player.getGraphic().setAnimation(action == Action::RELEASE ? Klinck::Animation::IDL_FRONT : Klinck::Animation::WALK_FRONT);
            this->_player.getGraphic().setCurrentAnimation(Klinck::Animation::IDL_FRONT);
        }

        if(key == Keyboard::Key::ARROW_DOWN) {
            this->_player.setMovingDirection(Klinck::Direction::DOWN, action != Action::RELEASE);
            //this->_player.getGraphic().setAnimation(action == Action::RELEASE ? Klinck::Animation::IDL_BACK : Klinck::Animation::WALK_BACK);
            this->_player.getGraphic().setCurrentAnimation(Klinck::Animation::IDL_BACK);
        }
    }
}