#pragma once

#include "Component.hpp"
#include <engine/utility/Priority.hpp>

namespace megu::kernel {
    template <class E>
    class Graphical : public Component<E> {
        public:
            inline Graphical(Priority = 0, Priority = 0);

            inline Priority getLayerPriority() const {return this->_layer;}
            inline Priority getObjectPriority() const {return this->_object;}

            inline void setLayerPriority(Priority p) {this->_layer = p;}
            inline void setLayerObject(Priority p) {this->_object = p;}

            virtual void update(double) = 0;

        private:
            Priority _layer;
            Priority _object;
            
    }; 
}

#include "Graphical.tpp"