#pragma once

#include "Component.hpp"

#include <functional>
#include <utility/Identifiable.hpp>
#include <engine/utility/Priority.hpp>

namespace megu::kernel {
    template <class E>
    class Physical : public Component<E> {
        public:
            Physical(Priority p = 0);
   virtual ~Physical() = default;

            inline void setLayer(Priority p) {this->_layer = p;}
            inline Priority getLayer() const {return this->_layer;}

            virtual void onCollide(Kernel &, E &, Identifiable &, Physical &, double) = 0;

            using CollideLambda = std::function<void(Kernel &, E &, Identifiable &, Physical &, double)>;
            
        private:
            Priority _layer;
    };  
}

#include "Physical.tpp"