#pragma once

namespace megu::kernel {
    class Props;
    class Kernel;

    template <class T, class C, class O>
    class Engine {
        public:
            virtual void boot() = 0;
            virtual void stop() = 0;
            virtual void step(double) = 0;  

            virtual T & get() = 0;
            virtual const O & get(const C &) const = 0;

            virtual void push(C &) = 0;
            virtual void remove(C &) = 0;
    };
}