#include "GraphicEngine.hpp"

#include <kernel/front/Kernel.hpp>

namespace megu::kernel {
    GraphicEngine::GraphicEngine(Window & window) 
    : _engine(window), _renderer(360, 360) {}

    void GraphicEngine::boot() {
        this->_engine.push(0, this->_renderer);
        this->_engine.push(1, this->_renderer);
        this->_engine.push(2, this->_renderer);
    }

    void GraphicEngine::stop() {

    }

    void GraphicEngine::step(double time) {
        this->_engine.step();
    }

    void GraphicEngine::push(Graphical<GraphicEngine> & graphical) {
        graphical.apply(*this);
    }

    void GraphicEngine::remove(Graphical<GraphicEngine> & graphical) {
        graphical.unapply(*this);
    }

    const Renderable & GraphicEngine::get(const Graphical<GraphicEngine> & graphical) const {
        auto object = this->_engine.get(graphical);
        if(object.has_value()) {
            return object.value();
        } 
        throw std::runtime_error("Cannot find in physic object : " + graphical.id());
    }
}