#include "PhysicEngine.hpp"

#include <iostream>

namespace megu::kernel {
    PhysicEngine::PhysicEngine()
    : _engine() {}

    void PhysicEngine::boot() {
        
    }

    void PhysicEngine::stop() {

    }

    void PhysicEngine::step(double time) {
        this->_engine.step(time);
    }

    void PhysicEngine::push(Physical<PhysicEngine> & props) {
        props.apply(*this);
    }

    void PhysicEngine::remove(Physical<PhysicEngine> & props) {
        props.unapply(*this);
    }

    const megu::Tangible & PhysicEngine::get(const Physical<PhysicEngine> & props) const {
        auto tangible = this->_engine.get(props);
        if(tangible.has_value()) {
            return tangible.value();
        }
        throw std::runtime_error("Cannot find in physic object : " + props.id());
         
    }
}