#pragma once

#include "Engine.hpp"

#include <engine/physic/front/engine/Engine.hpp>
#include <kernel/back/component/Physical.hpp>

namespace megu::kernel {
    class PhysicEngine : public Engine<megu::PhysicEngine, Physical<PhysicEngine>, Tangible> {
        public:
            PhysicEngine();

            inline megu::PhysicEngine & get() override {return this->_engine;}

            void boot() override;
            void stop() override;
            void step(double) override;

            void push(Physical<PhysicEngine> &) override;
            void remove(Physical<PhysicEngine> &) override;

            inline std::optional<SquareBox> check(SquareBox box, Priority prio) const {return this->_engine.checkCollision(box, prio);}

            const megu::Tangible & get(const Physical<PhysicEngine> &) const override;

        private:
            megu::PhysicEngine _engine;
    };
}