#pragma once

#include "Linker.hpp"
#include <kernel/back/engine/GraphicEngine.hpp>

#include <stack>
#include "RenderTrace.hpp"

namespace megu::kernel {
    template <class T>
    class GraphicLinker : public Linker<GraphicEngine> {
        public:
            GraphicLinker();

            void link(T &, Priority, Priority);
            void unlink(T &);

            void link(GraphicEngine &) override;
            void setModule(Module<ref_set<T>> *);

            inline bool haveModule() const {return this->_module.get() != nullptr;}

        private:
            std::unique_ptr<Module<ref_set<T>>> _module;

            std::map<RenderTrace, ref_set<T>> _stored;
            std::map<RenderTrace, size_t> _ids;
            std::set<RenderTrace> _await;
            std::set<RenderTrace> _delete;
    };
}

#include "GraphicLinker.tpp"
