#pragma once

#include "Linker.hpp"
#include <kernel/back/engine/GraphicEngine.hpp>

#include "RenderTrace.hpp"

namespace megu::kernel {
    template <class T>
    class UniqueGraphicLinker : public Linker<GraphicEngine> {
        public:
            UniqueGraphicLinker();

            void link(T &, Priority, Priority);
            void unlink(T &);

            void link(GraphicEngine &) override;
            void setModule(Module<T> *);

            inline bool haveModule() const {return this->_module.get() != nullptr;}

        private:
            std::unique_ptr<Module<T>> _module;
            std::map<RenderTrace, std::pair<std::reference_wrapper<T>, size_t>> _stored;
            std::map<RenderTrace, std::reference_wrapper<T>> _await;
            std::map<RenderTrace, size_t> _ids;

            std::set<RenderTrace> _delete;

    };
}

#include "UniqueLinker.tpp"
