#pragma once

#include <kernel/back/component/Physical.hpp>
#include <kernel/back/engine/PhysicEngine.hpp>

#include <engine/physic/front/object/TangibleStatic.hpp>
#include <functional>
#include <optional>

namespace megu::kernel {
    class Fixed : public TangibleStatic, public Physical<PhysicEngine> {
        public:
            Fixed() = delete;
            Fixed(float x, float y, float w, float h, CollideLambda = nullptr, UpdateLambda = nullptr);
   virtual ~Fixed() = default;

            void updatePhysic(double) const override;
            void onCollide(Kernel &, PhysicEngine &, Identifiable &, Physical &, double) override;
            void apply(PhysicEngine &) override;
            void unapply(PhysicEngine &) override;

            void setCollideLambda(CollideLambda);
            void setUpdateLambda(UpdateLambda);

        private:
            CollideLambda _collide;
            UpdateLambda _update;
    };
}