#include "Tile.hpp"

namespace megu::kernel {
    Tile::Tile()
    : Fixed(0, 0, 1, 1) {}

    Tile::Tile(float x, float y, float d, Priority p)
    : Fixed(x, y, d, d) {
        this->setLayer(p);
    }

    bool Tile::operator==(const Tile & tile) const {
        return this->id() == tile.id();
    }

    bool Tile::operator>=(const Tile & tile) const {
        return this->id() >= tile.id();
    }

    bool Tile::operator<=(const Tile & tile) const {
        return this->id() <= tile.id();
    }

    bool Tile::operator>(const Tile & tile) const {
        return this->id() > tile.id();
    }

    bool Tile::operator<(const Tile & tile) const {
        return this->id() < tile.id();
    }
}