#pragma once


#include <utility/Identifiable.hpp>
#include <kernel/back/component/Physical.hpp>
#include <kernel/back/component/Graphical.hpp>

#include <kernel/back/engine/PhysicEngine.hpp>
#include <kernel/back/engine/GraphicEngine.hpp>

namespace megu::kernel {
    template <class P, class G>
    class BaseProps : virtual public Identifiable {
        public:
            using Graphical_Component = Graphical<G>;
            using Physical_Component = Physical<P>;
            
            virtual Graphical_Component * getGraphicComponent() = 0;   
            virtual Physical_Component * getPhysicComponent() = 0;
    };

    using Prop = BaseProps<PhysicEngine, GraphicEngine>;
}