#pragma once

#include <kernel/front/props/Props.hpp>
#include <kernel/front/component/graphic/Sprite.hpp>
#include <kernel/front/component/physic/Movable.hpp>

namespace megu::kernel {
    class PropsDynamic : public Prop {
        public:
            PropsDynamic() = delete;
            PropsDynamic(Sprite &, Movable &);
   virtual ~PropsDynamic() = default;

            inline Prop::Graphical_Component * getGraphicComponent() {return &this->_graphic;}
            inline Prop::Physical_Component * getPhysicComponent() {return &this->_physic;}

        private:
            Sprite & _graphic;
            Movable & _physic;
    };
}