#pragma once

#include <kernel/front/props/Props.hpp>
#include <kernel/front/component/graphic/Sprite.hpp>
#include <kernel/front/component/physic/Movable.hpp>

#include <engine/io/Profiler.hpp>

namespace megu {
    class Window;
}

namespace megu::kernel {
    class PropsPlayable : public Prop {
        public:
            PropsPlayable() = delete;
            PropsPlayable(Sprite &, Movable &);
   virtual ~PropsPlayable() = default;

            void setControl(Window &, Keyboard *);
            void setControl(Window &, Mouse *);

            virtual Prop::Graphical_Component * getGraphicComponent() {return &this->_graphic;}   
            virtual Prop::Physical_Component * getPhysicComponent() {return &this->_physic;}

        private:
            Sprite & _graphic;
            Movable & _physic;
            Profiler _profiler;
    };
}