#pragma once

#include <kernel/front/props/Props.hpp>
#include <kernel/front/component/graphic/Sprite.hpp>
#include <kernel/front/component/physic/Fixed.hpp>

namespace megu::kernel {
    class PropsStatic : public Prop {
        public:
            PropsStatic() = delete;
            PropsStatic(Sprite &, Fixed &);
   virtual ~PropsStatic() = default;

            inline Prop::Graphical_Component * getGraphicComponent() override {return &this->_graphic;}
            inline Prop::Physical_Component * getPhysicComponent() override {return &this->_physic;}

        private:
            Sprite & _graphic;
            Fixed & _physic;
    };
}