#pragma once

#include <kernel/front/props/Props.hpp>
#include <kernel/front/component/graphic/TileMap.hpp>
#include <kernel/front/component/physic/TileArray.hpp>

namespace megu::kernel {
    class PropsTileMap : public Prop {
        public:
            PropsTileMap() = delete;
            PropsTileMap(Tilemap &, TileArray &);
   virtual ~PropsTileMap() = default;

            inline Prop::Graphical_Component * getGraphicComponent() override {return &this->_graphic;}
            inline Prop::Physical_Component * getPhysicComponent() override {return &this->_physic;}

        private:
            Tilemap & _graphic;
            kernel::TileArray & _physic;  
    };
}