#include "PhysicResolver.hpp"

#include <kernel/front/Kernel.hpp>

namespace megu::kernel {
    void PhysicResolver::resolve(Kernel & kernel, PhysicEngine & engine, double time) {
        auto & collisions = engine.get().collision();

        for(auto & collision : collisions) {
            auto source_comp = this->get(collision.source());
            auto target_comp = this->get(collision.target());

            if(source_comp.has_value() && target_comp.has_value()) {
                source_comp.value().get().onCollide(kernel, engine, *kernel.get(target_comp.value()), target_comp.value(), time);
            }
        }

        engine.get().clearCollision();
    }
}