#pragma once

#include <optional>
#include <utility/Identifiable.hpp>
#include <engine/utility/ref_set.hpp>
#include <kernel/back/component/Component.hpp>

namespace megu::kernel {
    template <class E, class O>
    class Resolver {
        public:
            inline ref_set<O> & components() {return this->_components;}

            void push(O &);
            void remove(const Identifiable &);
            std::optional<std::reference_wrapper<O>> get(const Identifiable &);

            virtual void resolve(Kernel &, E &, double) = 0;

        private:
            ref_set<O> _components;
    };
}

#include "Resolver.tpp"