#include "Resolver.hpp"

namespace megu::kernel {
    template <class E, class O>
    void Resolver<E, O>::push(O & c) {
        this->_components.insert(c);
    }

    template <class E, class O>
    void Resolver<E, O>::remove(const Identifiable & c) {
        auto it = std::find(this->_components.begin(), this->_components.end(), c);
        this->_components.erase(it);
    }

    template <class E, class O>
    std::optional<std::reference_wrapper<O>> Resolver<E, O>::get(const Identifiable & c) {
        for(auto & comp : this->_components) {
            if(comp.get().id() == c.id()) {
                return comp;
            }
        }
        return {};
    }
}