#include "Identifiable.hpp"

namespace megu {
    size_t Identifiable::_GlobalId = 0;

    Identifiable::Identifiable()
    : _id(++Identifiable::_GlobalId) {}

    Identifiable::Identifiable(size_t id)
    : _id(id) {}

    Identifiable::Identifiable(const Identifiable & src)
    : _id(src._id) {}

    Identifiable::~Identifiable() {
        --Identifiable::_GlobalId;
    }

    bool Identifiable::operator==(const Identifiable & identifiable) const {
        return this->_id == identifiable._id;
    }

    /*bool Identifiable::operator!=(const Identifiable & identifiable) const {
        return !(*this == identifiable);
    }*/

    bool Identifiable::operator<=(const Identifiable & identifiable) const {
        return this->_id <= identifiable._id;
    }

    bool Identifiable::operator>=(const Identifiable & identifiable) const {
        return this->_id <= identifiable._id;
    }

    bool Identifiable::operator<(const Identifiable & identifiable) const {
        return !(this->_id >= identifiable._id);
    }

    bool Identifiable::operator>(const Identifiable & identifiable) const {
        return !(this->_id <= identifiable._id);
    }
}