#pragma once

#include <map>
#include <stddef.h>

namespace megu {
    class Identifiable {
        public:
            Identifiable();
            Identifiable(size_t);
            Identifiable(const Identifiable &);
   virtual ~Identifiable();

            inline size_t id() const {return this->_id;}
            inline void setId(size_t id) {this->_id = id;}

            bool operator==(const Identifiable &) const;
            //bool operator!=(const Identifiable &) const;
            bool operator>=(const Identifiable &) const;
            bool operator<=(const Identifiable &) const;
            
            bool operator>(const Identifiable &) const;
            bool operator<(const Identifiable &) const;

            static size_t GloabalId() {return Identifiable::_GlobalId;}

        private:
            size_t _id;
            static size_t _GlobalId;
    };
    
    template <class T>
    using Identifiable_Map = std::map<size_t, T *>;

    template <class T>
    class Identifiable_Unique : public Identifiable {};
}